#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Blue
//---- input parameters
extern int       N_Max=50;   //  -       
extern double    StdDev_Max=1.7;  //          
int              Svechi=0 ;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double   LineCenter[];
double   LineUp[];
double   LineDown[];
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
   if (Bars==Svechi) return(0);
   Svechi=Bars ;
   int    i,aaa=0,N2=0,N3=0;
   double  StdDev1=0,StdDev2=0,StdDev3,StdDev4;
   if ((Bars < N_Max+1) || (N_Max<=3)) return(0);
      for (int N=3;N<=N_Max;N++)
   {  for (StdDev1=1.0; StdDev1<=StdDev_Max; StdDev1+=0.02)
      {
         i=Chanel(N, StdDev1);
         for   (i=0;i<=N;i++)
            { if (iHigh(NULL,0,i)>LineUp[i] && iClose(NULL,0,i)>LineDown[i] && iClose(NULL,0,i)<LineUp[i] ||
                   iLow(NULL,0,i)<LineDown[i]&& iClose(NULL,0,i)<LineUp[i] && iClose(NULL,0,i) >LineDown[i])
                   aaa++ ;
            }
             if (aaa > N2) 
               {  N2=aaa  ;  StdDev2=StdDev1 ; N3=N  ; } 
                  aaa=0 ;
       }
   }         
//      Alert("   ", StdDev2);
//      Alert("   ", StdDev4);
//      Alert("   " , N3); 
      for (i=0;i<=N_Max; i++)
      { ExtMapBuffer1[i]=EMPTY_VALUE  ;
        ExtMapBuffer2[i]=EMPTY_VALUE ;
        ExtMapBuffer3[i]=EMPTY_VALUE;
      } 
      i=Chanel(N3, StdDev2);
      for (int x=1;x<=N3;x++)
      {  i=N3-x; 
         ExtMapBuffer1[i]=LineCenter[i]; 
         ExtMapBuffer2[i]=LineUp[i];
         ExtMapBuffer3[i]=LineDown[i];
      }
    return(0);
  }
  
  int Chanel(int n,double StdDev1)
  {//           n   StdDev  
   int    j;
   double   a,b,Summ_x,Summ_y,Summ_x_2,Summ_xy,Deviation,StdDeviation,Sredn_y;
   ArrayResize(LineCenter,n);
   ArrayResize(LineUp,n);
   ArrayResize(LineDown,n);
   for (int x=1;x < n;x++)
   {  j=n-x;  
      Summ_x=Summ_x+x;  
      Summ_y=Summ_y+Close[j];   
      Summ_xy=Summ_xy+x*Close[j]; 
      Summ_x_2=Summ_x_2+MathPow(x,2); 
   }
      b=((n-1)*Summ_xy-Summ_x*Summ_y)/((n-1)*Summ_x_2-MathPow(Summ_x,2));  
      a=(Summ_y-b*Summ_x)/(n-1);
      Sredn_y=Summ_y/(n-1);
   for (x=1;x < n;x++)
      {
         j=n-x;
         Deviation=Deviation+MathPow((Close[j]-Sredn_y),2);
      }
         StdDeviation=MathSqrt(Deviation/n);
         for (x=1;x<=n;x++)
      {  j=n-x;   
         LineCenter[j]=NormalizeDouble((b*x+a),Digits); 
         LineUp[j]=NormalizeDouble((b*x+a+StdDev1*StdDeviation),Digits);
         LineDown[j]=NormalizeDouble((b*x+a-StdDev1*StdDeviation),Digits);
      }
      return(0);
  }    

